include graphics.e
include image.e
include mighty.e
include font.e

constant MENUB = load_font("sans08.f")

global constant
  MNU_NORMAL = 100,
  MNU_GRAYED = 101,
  MNU_CHECKED = 102

global procedure DrawMenu(sequence Menu, sequence Parent)
 atom px, py
 object pl
 select_font(MENUB)
 set_foreground(0)
 py = floor((Parent[1][2] + Parent[2][2]) / 2 - height() / 2)
 px = floor(Parent[1][1] + 10)
 mouse_pointer(0)
 polygon(7, 1, {Parent[1], {Parent[2][1],Parent[1][2]}, Parent[2], {Parent[1][1],Parent[2][2]}})
 draw_line(08, {Parent[2], {Parent[2][1], Parent[2][2]}})
 draw_line(08, {Parent[2], {Parent[1][1], Parent[2][2]}})
 draw_line(15, {Parent[1], {Parent[2][1], Parent[1][2]}})
 draw_line(15, {Parent[1], {Parent[1][1], Parent[2][2]}})
 for c = 1 to length(Menu) do
   if px >= Parent[2][1] then exit end if
   setx(px) sety(py) write(Menu[c][1])
   pl = lengths(Menu[c][1])
   if sequence(pl) then
    px += pl[1] + 21
   elsif integer(pl) then
    px += pl + 20
   end if
 end for
 mouse_pointer(1)
end procedure

global procedure MouseMenu(sequence setting, sequence Menu, sequence Parent)
 atom px, py, vx, x, y, c1, c2
 object pl
 x = setting[2] y = setting[3]
 if and_bits(setting[1], LEFT_DOWN) then
  c1 = 08 c2 = 15
 else
  c1 = 15 c2 = 08
 end if
 select_font(MENUB)
 set_foreground(0)
 py = floor((Parent[1][2] + Parent[2][2]) / 2 - height() / 2)
 px = floor(Parent[1][1] + 10)
 if (y >= py - 2) and (py <= py + height() + 2) and
    (x >= Parent[1][1]) and (x <= Parent[2][1]) then
  mouse_pointer(0)
  for c = 1 to length(Menu) do
    if px >= Parent[2][1] then exit end if
    setx(px) sety(py) write(Menu[c][1])
    pl = lengths(Menu[c][1])
    vx = px + 1
    if sequence(pl) then
     px += pl[1] + 21
    elsif integer(pl) then
     px += pl + 21
    end if
    if (x > vx - 10) and (x < px - 10) and (y >= py - 1) and (y <= py + height() + 2) then
     draw_line(c1, {{vx - 08, py - 1}, {px - 08, py - 1}})
     draw_line(c1, {{vx - 08, py - 1}, {vx - 08, py + height() + 2}})
     draw_line(c2, {{vx - 08, py + height() + 2}, {px - 08, py + height() + 2}})
     draw_line(c2, {{px - 08, py - 1}, {px - 08, py + height() + 2}})
     setx(vx-1) sety(py)
     if c1 = 08 then set_foreground(0) else set_foreground(15) end if
     write(Menu[c][1])
     set_foreground(0)
    else
     polygon(07, 0, {{vx - 08, py - 1}, {px - 08, py - 1}, {px - 08, py + height() + 2}, {vx - 08, py + height() + 2}})
    end if
  end for
  mouse_pointer(1)
 end if
end procedure

global function DrawVMenu(integer x, integer y, sequence Menu)
 atom mx, px, py
 object pl
 sequence bck
 mx = 0
 for c = 1 to length(Menu) do
  pl = lengths(Menu[c][1]) 
  if pl[1] > mx then
   mx = pl[1]
  end if
 end for
 bck = save_image({x, y}, {x + mx + 20, y + (length(Menu) * height()) + (length(Menu) * 4) + 10})
 polygon(7, 1, {{x, y}, {x + mx + 20, y}, {x + mx + 20, y + (length(Menu) * height()) + (length(Menu) * 4) + 10}, {x, y + (length(Menu) * height()) + (length(Menu) * 4) + 10}})
 polygon(8, 0, {{x, y}, {x + mx + 20, y}, {x + mx + 20, y + (length(Menu) * height()) + (length(Menu) * 4) + 10}, {x, y + (length(Menu) * height()) + (length(Menu) * 4) + 10}})
 draw_line(15, {{x, y}, {x + mx + 20, y}})
 draw_line(15, {{x, y}, {x, y + (length(Menu) * height()) + (length(Menu) * 4) + 10}})
 px = x + 10 py = floor(y + 5) set_foreground(0)
 for c = 1 to length(Menu) do
  if compare(Menu[c][1], "-") then
   if Menu[c][4] != MNU_GRAYED then
    setx(px) sety(py) write(Menu[c][1])
   else
    set_foreground(15) setx(px+1) sety(py+1) write(Menu[c][1])
    set_foreground(8) setx(px) sety(py) write(Menu[c][1])
    set_foreground(0)
   end if
   if Menu[c][4] = MNU_CHECKED then
    draw_line(15, {{px - 7, floor(py + height() / 2 - 2)},{px-3, floor(py + height() / 2 - 2)}})
    draw_line(15, {{px - 7, floor(py + height() / 2 - 2)},{px-7, floor(py + height() / 2 + 2)}})
    draw_line(08, {{px - 7, floor(py + height() / 2 + 2)},{px-3, floor(py + height() / 2 + 2)}})
    draw_line(08, {{px - 3, floor(py + height() / 2 - 2)},{px-3, floor(py + height() / 2 + 2)}})
   end if
  else
   draw_line(0, {{px - 8, floor(py + height() / 2)}, {px + mx + 7, floor(py + height() / 2)}})
   draw_line(15, {{px - 7, floor(py + height() / 2 + 1)}, {px + mx + 8, floor(py + height() / 2 + 1)}})
  end if
  py += height() + 4
 end for
 return bck
end function

function RetVMenu(integer q, integer mx, integer my, integer x, integer y, sequence Menu, integer pre)
 atom max, py, atd, c1, c2
 object pl
 if not and_bits(q, LEFT_DOWN) then
  c1 = 15 c2 = 08
 else
  c1 = 08 c2 = 15
 end if
 select_font(MENUB)
 atd = 0
 max = 0
 py = y + 5
 for c = 1 to length(Menu) do
  pl = lengths(Menu[c][1])
  if sequence(pl) then
   if pl[1] > max then
    max = pl[1]
   end if
  end if
 end for
 max += 20
 mouse_pointer(0)
 for c = 1 to length(Menu) do
  if compare(Menu[c][1], "-") and Menu[c][4] != MNU_GRAYED then
   if c = pre then
    draw_line(07, {{x + 1, py - 1}, {x + max - 1, py - 1}})
    draw_line(07, {{x + 1, py - 1}, {x + 1, py + height() + 2}})
    draw_line(07, {{x + 1, py + height() + 2}, {x + max - 1, py + height() + 2}})
    draw_line(07, {{x + max - 1, py - 1}, {x + max - 1, py + height() + 2}})
   end if
   if mx >= x and mx <= x + max and my >= py - 1 and my <= py + height() + 2 then
    atd = c
    draw_line(c1, {{x + 1, py - 1}, {x + max - 1, py - 1}})
    draw_line(c1, {{x + 1, py - 1}, {x + 1, py + height() + 2}})
    draw_line(c2, {{x + 1, py + height() + 2}, {x + max - 1, py + height() + 2}})
    draw_line(c2, {{x + max - 1, py - 1}, {x + max - 1, py + height() + 2}})
   end if
  end if
  py += height() + 4
 end for
 mouse_pointer(1)
 return atd
end function

function RetMenu(integer x, integer y, sequence Menu, sequence Parent)
 atom px, py, vx
 object pl
 py = floor((Parent[1][2] + Parent[2][2]) / 2 - height() / 2)
 px = floor(Parent[1][1] + 10)
 for c = 1 to length(Menu) do
   if px >= Parent[2][1] then exit end if
   setx(px) sety(py) write(Menu[c][1])
   pl = lengths(Menu[c][1])
   vx = px + 1
   if sequence(pl) then
    px += pl[1] + 21
   elsif integer(pl) then
    px += pl + 21
   end if
   if (x > vx - 10) and (x < px - 10) and (y >= py - 1) and (y <= py + height() + 2) then
    return {c, vx}
   end if
 end for
 return {0, 0}
end function

procedure ActMenu(integer nr, integer x, sequence Menu, sequence Parent)
 object m, q
 integer ot, at
 sequence back
 q = {}
 ot = nr
 at = 1
 mouse_pointer(0)
 back = DrawVMenu(x, Parent[2][2]+1, Menu[nr][2])
 mouse_pointer(1)
 while 1 do
  m = get_mouse()
  if sequence(m) then
   if and_bits(m[1], MOVE) then
    q = RetMenu(m[2], m[3], Menu, Parent)
    if sequence(q) then ot = q[1] end if
    if ot != nr and ot != 0 then
     nr = ot
     m[1] = LEFT_DOWN
     MouseMenu(m, Menu, Parent)
     mouse_pointer(0)
     display_image({x, Parent[2][2]+1}, back)
     x = q[2] + 5
     back = DrawVMenu(x, Parent[2][2]+1, Menu[nr][2])
     mouse_pointer(1)
    else
     at = RetVMenu(m[1], m[2], m[3], x, Parent[2][2]+1, Menu[nr][2], at)
    end if
   end if
   if and_bits(m[1], LEFT_DOWN) then
    at = RetVMenu(m[1], m[2], m[3], x, Parent[2][2]+1, Menu[nr][2], at)
   end if
   if and_bits(m[1], LEFT_UP) then
    at = RetVMenu(m[1], m[2], m[3], x, Parent[2][2]+1, Menu[nr][2], at)
    mouse_pointer(0)
    display_image({x, Parent[2][2]+1}, back)
    mouse_pointer(1)
    if at != 0 then
     call_proc(Menu[nr][2][at][2], {Menu[nr][2][at][3]})
    end if
    exit
   end if
  end if
 end while
end procedure

global procedure MenuClick(integer x, integer y, sequence Menu, sequence Parent)
 atom px, py, vx
 object pl
 select_font(MENUB)
 set_foreground(0)
 py = floor((Parent[1][2] + Parent[2][2]) / 2 - height() / 2)
 px = floor(Parent[1][1] + 10)
 for c = 1 to length(Menu) do
   if px >= Parent[2][1] then exit end if
   setx(px) sety(py) write(Menu[c][1])
   pl = lengths(Menu[c][1])
   vx = px + 1
   if sequence(pl) then
    px += pl[1] + 21
   elsif integer(pl) then
    px += pl + 21
   end if
   if (x > vx - 10) and (x < px - 10) and (y >= py - 1) and (y <= py + height() + 2) then
    ActMenu(c, vx + 5, Menu, Parent)
    exit
   end if
 end for
end procedure
